'=============================='
'OBJ2MI
'------------------------------'
'This script extracts all objects from table in separate files
'         
'=============================='

'=============================='
Option Explicit
'------------------------------'
Const TAB_INFO_NROWS = 8
'------------------------------'
Dim MI			' object Mapinfo.Application /  Mapinfo.Application
Dim WSH			' object WScript.Shell /  WScript.Shell
Dim sPath		' table path /  
Dim i, iCount		' counters / 
'------------------------------'
Const S_Tab = "myTable"	' table name /  
Const S_Sel = "myQuery"	' selection name /  
'=============================='

'=============================='
'RUN / 
'------------------------------'
On Error Resume Next
	Set MI = GetObject(, "mapinfo.application") ' call to mapinfo object /    mapinfo
	If Err.Number = 429 Then ' if app don't run /  mapinfo   
		Set MI = CreateObject("mapinfo.application") ' create mapinfo object /   mapinfo
	End If
	MI.Visible = True ' show mapinfo window /   mapinfo
	Set WSH = CreateObject("wscript.shell")
	WSH.AppActivate MI.Name
	MI.Do ("Note ""I'm ready!""") ' send test command /  
	sPath = MI.Eval("FileOpenDlg("""","""",""TAB"","""")") ' get table name /   
	If Len(sPath) = 0 Then Call EndScript
	MI.Do ("Open Table """ & sPath & """ as " & S_Tab) ' open table /  
	iCount = CInt(MI.Eval("TableInfo(""" & S_Tab & """," & TAB_INFO_NROWS & ")")) ' get number strings /   
	MI.Do ("Print ""Items: " & CStr(iCount) & """") ' service message /  
	For i = 1 To iCount
		MI.Do ("Select * From " & S_Tab & " Where RowId=" & CStr(i) & " Into " & S_Sel) ' select object '  
		MI.Do ("Export """ & S_Sel & """ Into """ & CStr(i) & ".Mif"" Type ""mif"" Overwrite") ' export to mif /   mif
		MI.Do ("Close Table " & S_Sel) ' close query /  
		MI.Do ("Print """ & CStr(i) & """") ' service message /  
	Next
	MI.Do ("Close Table " & S_Tab) ' close table /  
	Call EndScript

'=============================='
'EXIT / 
'------------------------------'
Sub EndScript()
	If MsgBox (_
	 "I go out :(" & vbNewLine & "Close MapInfo?", _
	 vbCritical + vbYesNo, _
	 "ERROR") = vbYes Then
		MI.Do ("End MapInfo Interactive")
	End If
	Set MI = Nothing
	Set WSH = Nothing
	WScript.Quit
End Sub

'=============================='
'OBJ2MIF
'------------------------------'
'Ciril V. Golubev2009-2011
'tribute for http://glab2007@narod.ru
'=============================='